# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           dbunit
Summary:        DBUnit extension for JUnit
Url:            http://dbunit.sourceforge.net/
Version:        2.4.2
Release:        1%{?dist}
Epoch:          0
License:        LGPL
Group:          Development/Testing
BuildArch:      noarch
Source0:        %{name}-%{version}.tar.gz
# svn export http://dbunit.svn.sourceforge.net/svnroot/dbunit/tags/release-2.4.2/ dbunit-2.4.2

Source1:        dbunit-settings.xml
Source2:        dbunit-2.4.2-jpp-depmap.xml
Patch0:         dbunit-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  ant-junit
BuildRequires:  junit
BuildRequires:  junit-addons
BuildRequires:  derby
BuildRequires:  gsbase
BuildRequires:  hsqldb
BuildRequires:  mockmaker
BuildRequires:  mockobjects >= 0:0.09-17
BuildRequires:  mockobjects-jdk1.4 >= 0:0.09-17
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-skins
BuildRequires:  maven2-plugin-ant
BuildRequires:  maven2-plugin-changelog
BuildRequires:  maven2-plugin-changes
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit3
BuildRequires:  maven-surefire-report-plugin
BuildRequires:  maven-release
BuildRequires:  maven-jxr
BuildRequires:  mojo-cobertura-maven-plugin
BuildRequires:  mojo-maven2-plugin-jdepend
BuildRequires:  apache-commons-collections
BuildRequires:  apache-commons-lang
BuildRequires:  apache-poi
BuildRequires:  slf4j
Requires:  java >= 0:1.6.0
Requires:  ant
Requires:  junit
Requires:  junit-addons
Requires:  apache-commons-collections
Requires:  apache-commons-lang
Requires:  apache-poi
Requires:  slf4j
BuildRoot:     %{_tmppath}/%{name}-%{version}-buildroot
Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%description
DbUnit is a JUnit extension (also usable with Ant) targeted 
for database-driven projects that, among other things, puts 
your database into a known state between test runs. This is 
an excellent way to avoid the myriad of problems that can 
occur when one test case corrupts the database and causes 
subsequent tests to fail or exacerbate the damage. 
DbUnit has the ability to export and import your database 
data to and from XML datasets. Since version 2.0, DbUnit can 
works with very large dataset when use in streaming mode. 
DbUnit can also helps you to verify that your database data 
match expected set of values. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q 
chmod -R go=u-w *

cp %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml

%patch0 -b .sav0
#%patch1 -b .sav1

%build
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2_SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $M2_SETTINGS \
        -Dmaven.test.failure.ignore=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install javadoc:javadoc site


%install
%__rm -rf %{buildroot}

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/%{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.dbunit %{name} %{version} JPP %{name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 644 LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# manual
rm -rf target/site/apidocs
cp -pr target/site $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root)
%{_docdir}/%{name}-%{version}/site

%changelog
* Sat Aug 04 2012 Ralph Apel <r.apel at r-apel.de> 0:2.4.2-1
- 2.4.2 for JPP-6

* Tue Jul 01 2008 Ralph Apel <r.apel at r-apel.de> 0:2.2.1-2.jpp5
- Adapt to restructured mockobjects and require >= 0_0.09-17

* Mon Apr 07 2008 Ralph Apel <r.apel at r-apel.de> 0:2.2.1-1jpp
- 2.2.1
- build with maven2 by default

* Wed Mar 07 2007 Ralph Apel <r.apel at r-apel.de> 0:2.1-4jpp
- Add gcj_support option
- Optionally build without maven
- Revert to crimson BR instead of Xerces-j2 to get most unit
  tests succeeding with maven

* Mon Mar 13 2006 Fernando Nasser <fnasser@redhat.com> 0:2.1-3jpp
- Replace crimson with xerces-j2

* Fri Mar 10 2006 Fernando Nasser <fnasser@redhat.com> 0:2.1-2jpp
- First JPP 1.7 build
  From Deepak Bhole:
- Changed spec file to have maven build it's repository dynamically.

* Mon Feb 21 2005 Ralph Apel <r.apel at r-apel.de> 0:2.1-1jpp
- First release

